package com.taauav.admin.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * <p>图片管理的DTO字段</p>
 *
 * @author : dyg
 * @date : 2019-11-25 13:48
 **/
@Data
public class TauvInspectDriverPicDTO extends BaseInspectDriverDTO {
    /**
     * 图片数量
     */
    private Integer totalNum;
    /**
     * 标记图片
     */
    private Integer signNum;
    /**
     * 未标记图片
     */
    private Integer unsignNum;
    /**
     * 已复核数量
     */
    private Integer reviewNum;
    /**
     * 未复核数量
     */
    private Integer unreviewNum;
    /**
     * 有效数量
     */
    private Integer effectiveNum;
    /**
     * 无效数量
     */
    private Integer unEffectiveNum;
    /**
     * 复核人
     */
    private Integer reviewUser;
    private String formatReviewUser;
    /**
     * 复核时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date reviewTime;
    private String formatReviewTime;
    /**
     * 状态
     */
    private Integer status;
    private String statusText;

    /**
     * 巡检开始时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date executionTime;
    private String formatExecutionTime;
    /**
     * 最近上传时间
     */
    private String lastUploadTime;
    /**
     * 是否可以对图片和视频操作上传，查看，编辑等操作
     */
    private Integer canOption;
}
