package com.taauav.admin.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigInteger;
import java.util.Date;

/**
 * 正摄图管理列表请求实体类
 *
 * @author daixiantong
 * @date 2020-05-18
 */
@Data
public class TauvInspectPhotoDTO {

    /**
     * 任务单号
     */
    private String inspectNo;

    /**
     * 区属id
     */
    private BigInteger driverArea;

    /**
     * 河湖名称
     */
    private String driverName;

    /**
     * 巡检时间（开始）
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date startTime;

    /**
     * 巡检时间（结束）
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date endTime;
}
