package com.taauav.admin.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>报告DTO</p>
 *
 * @author : dyg
 * @date : 2019-11-29 13:58
 **/
@Data
public class TauvReportDTO extends BaseReportDTO {
//    /**
//     * 是否省/国考河道：1是 2否
//     */
//    private Byte driverExam;

    /**
     * 巡检总长度
     */
    private Integer inspectLength;

    /**
     * 状态值 1待生成 2审核中 3审核通过 4审核驳回
     */
    private Integer status;

    /**
     * 状态描述
     */
    private String statusText;

    /**
     * 飞行时间
     */
    private BigDecimal flightTime;

    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date createTime;

    /**
     * 生成报告时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date inputTime;

    /**
     * 格式化创建时间
     */
    private String formatInputTime;

    /**
     * 视频地址
     */
    private String videoUrl;

    /**
     * 正摄图地址
     */
    private String imageUrl;
}
