package com.taauav.admin.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 分区统计
 *
 * @author daixiantong
 * @date 2019-12-23
 */
@Data
public class TauvReportDriverDTO extends BaseReportDTO {

    /**
     * 报告ID
     */
    private Integer id;

    /**
     * 河道名称
     */
    private String driverName;

    /**
     * 巡检时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date inspectTime;

    /**
     * 格式化巡检时间
     */
    private String formatInspectTime;

    /**
     * 总分
     */
    private Integer totalExamineScore;

    /**
     * 问题总数
     */
    private Integer totalNum;

    /**
     * 水面问题数量
     */
    private Integer surfaceWater;

    /**
     * 岸线问题数量
     */
    private Integer shoreLine;

    /**
     * 排口问题数量
     */
    private Integer outfall;

    /**
     * 水质问题数量
     */
    private Integer waterQuality;

}
