package com.taauav.admin.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigInteger;
import java.util.Date;

/**
 * 水环境趋势列表请求实体类
 *
 * @author daixiantong
 * @date 2020-05-18
 */
@Data
public class TauvWaterTrendDTO {
    /**
     * 趋势编号
     */
    private String trendCode;
    /**
     * 区属id
     */
    private BigInteger driverArea;
    /**
     * 河湖名称
     */
    private String driverName;
    /**
     * 预测日期(开始)
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date startTime;
    /**
     * 预测日期(结束)
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date endTime;
}
