package com.taauav.admin.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.taauav.common.domain.Entity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 巡检正摄图对象 tauv_inspect_photo
 *
 * @author daixiantong
 * @date 20200518
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class TauvInspectPhoto extends Entity {

    private static final long serialVersionUID = 1L;

    /**
     * 巡检河流ID
     */
    private Integer inspectDriverId;
    /**
     * 正摄图地址
     */
    private String photoUrl;
    /**
     * 上传人id
     */
    private Integer uploadUser;
    /**
     * 上传时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date uploadTime;
}