package com.taauav.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.taauav.common.domain.Entity;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigInteger;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * 水质报警 实体类
 *
 * @author daixiantong
 * @date 2020-05-14
 */
@Data
public class TauvWaterAlarm extends Entity {

    /**
     * 巡检河道id
     */
    private Integer inspectDriverId;

    /**
     * 报警编码
     */
    private String alarmSn;

    /**
     * 区属id
     */
    private BigInteger driverArea;

    /**
     * 河道id
     */
    private Integer driverId;

    /**
     * 河湖名称
     */
    private String driverName;

    /**
     * 巡检日期
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date inspectTime;

    /**
     * 水质标准
     */
    private String alarmStandard;

    /**
     * 报警信息
     */
    private String alarmInfo;

    /**
     * 报警时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date alarmTime;

    /**
     * 状态描述
     */
    @TableField(exist = false)
    private String statusText;

    public Map<String, String> statusList() {
        Map<String, String> map = new HashMap<>();
        map.put("1", "未报警");
        map.put("2", "已报警");
        map.put("3", "已取消");
        map.put("4", "处理中");
        map.put("5", "处理完成");
        return map;
    }
}
