package com.taauav.admin.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.taauav.common.domain.Entity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigInteger;
import java.util.Date;

/**
 * 多光谱图对象 tauv_water_spectrum
 *
 * @author daixiantong
 * @date 20200514
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class TauvWaterSpectrum extends Entity {

    private static final long serialVersionUID = 1L;

    /**
     * 巡检河道id
     */
    private Integer inspectDriverId;
    /**
     * 任务单号
     */
    private String inspectNo;
    /**
     * 区属id
     */
    private BigInteger areaId;
    /**
     * 区属名称
     */
    private String areaName;
    /**
     * 河湖id
     */
    private Integer driverId;
    /**
     * 河湖名称
     */
    private String driverName;
    /**
     * 巡检时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date inspectTime;
    /**
     * 化学需氧量多光谱路径
     */
    private String codPic;
    /**
     * 氨氮多光谱路径
     */
    private String nh3nPic;
    /**
     * 总磷多光谱路径
     */
    private String tpPic;
    /**
     * 总氮多光谱路径
     */
    private String tnPic;
    /**
     * 溶解氧多光谱路径
     */
    private String doPic;
    /**
     * 浊度多光谱路径
     */
    private String tubPic;
}