package com.taauav.admin.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.taauav.common.domain.Entity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Date;

/**
 * 水环境趋势模拟对象 tauv_water_trend
 *
 * @author daixiantong
 * @date 20200515
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class TauvWaterTrend extends Entity {

    private static final long serialVersionUID = 1L;

    /**
     * 趋势编号
     */
    private String trendCode;
    /**
     * 区属id
     */
    private BigInteger driverArea;
    /**
     * 区属名称
     */
    private String areaName;
    /**
     * 河湖id
     */
    private Integer driverId;
    /**
     * 河湖名称
     */
    private String driverName;
    /**
     * 预测日期
     */
    @JsonFormat(pattern = "yyyy-MM", timezone = "GMT+8")
    private Date forecastTime;
    /**
     * 化学需氧量
     */
    private BigDecimal waterCod;
    /**
     * 氨氮
     */
    private BigDecimal waterNh3n;
    /**
     * 总磷
     */
    private BigDecimal waterTp;
    /**
     * 总氮
     */
    private BigDecimal waterTn;
    /**
     * 溶解氧
     */
    private BigDecimal waterDo;
    /**
     * 浊度
     */
    private BigDecimal waterTub;
}