package com.taauav.admin.query;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.taauav.common.core.mps.BaseQuery;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigInteger;
import java.util.Date;

/**
 * 水质数据请求实体类
 *
 * @author daixiantong
 * @date 2020-05-14
 */
@Data
public class TauvWaterDataQuery extends BaseQuery {

    /**
     * 任务单号
     */
    private String inspectNo;

    /**
     * 区属
     */
    private BigInteger  driverArea;

    /**
     * 河湖名称
     */
    private String driverName;

    /**
     * 巡检开始时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date startTime;

    /**
     * 巡检结束时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date endTime;
}
