package com.taauav.admin.service;

import com.taauav.common.bean.Response;
import com.taauav.admin.entity.SysPosition;
import com.taauav.common.service.IBaseService;

import java.util.Map;

/**
 * <p>
 * 职位表 服务类
 * </p>
 *
 * @author dyg
 * @since 2019-11-12
 */
public interface ISysPositionService extends IBaseService<SysPosition> {
    /**
     * 岗位列表
     *
     * @param map
     * @return
     */
    Response index(Map<String, String> map);

    /**
     * 添加、编辑岗位
     *
     * @param map
     * @return
     */
    Response edit(SysPosition map);

    /**
     * 根据id获取岗位数据
     *
     * @param id
     * @return
     */
    Response getPositionInfo(Integer id);

    /**
     * 删除岗位
     *
     * @param id
     * @return
     */
    Response drop(Integer id);

    /**
     * 修改岗位状态
     *
     * @param id
     * @param status
     * @return
     */
    Response changeStatus(Integer id, Integer status);
}
