package com.taauav.admin.service;

import com.taauav.admin.entity.TauvDriverPoint;
import com.taauav.common.service.IBaseService;

import java.math.BigInteger;
import java.util.List;
import java.util.Map;

/**
 * 河道坐标
 * @author dyg
 */
public interface ITauvDriverPointService extends IBaseService<TauvDriverPoint> {

    /**
     * 根据河湖id获取河湖对应坐标点
     * @param driverId
     * @return
     */
    List<TauvDriverPoint> getListByDriverId(int driverId);

    /**
     * 根据区划id获取对应所有河流的坐标点
     * @param cityId
     * @return
     */
    List<Map<String, String>> getPointListByCityId(BigInteger cityId);
}
