package com.taauav.admin.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.taauav.admin.mapper.*;
import com.taauav.admin.vo.TauvInspectFileDataVo;
import com.taauav.common.bean.Response;
import com.taauav.admin.dto.TauvInspectDriverPicDTO;
import com.taauav.admin.entity.*;
import com.taauav.admin.service.*;
import com.taauav.common.service.impl.BaseServiceImpl;
import com.taauav.common.util.*;
import org.apache.commons.beanutils.ConvertUtils;
import org.apache.commons.codec.digest.DigestUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;
import sun.misc.BASE64Decoder;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.math.BigInteger;
import java.util.*;
import java.util.List;

/**
 * <p>
 * 巡检附件表 服务实现类
 * </p>
 *
 * @author dyg
 * @since 2019-11-14
 */
@Service
public class TauvInspectFileServiceImpl extends BaseServiceImpl<TauvInspectFileMapper, TauvInspectFile> implements ITauvInspectFileService {
    @Value("${spring.pageSize}")
    private Integer pageSize;
    @Value("${file.uploadFolder}")
    private String uploadFolder;
    @Value("${server.UPLOAD_URL}")
    private String uploadUrl;
    @Autowired
    private TauvInspectFileMapper inspectFileMapper;
    @Autowired
    private TauvInspectDriverMapper inspectDriverMapper;
    @Autowired
    private ISysDictService iSysDictService;
    @Autowired
    private Response response;
    @Autowired
    private ISysCityService iSysCityService;
    @Autowired
    private ISysAdminService iSysAdminService;
    @Autowired
    private TauvReportMapper reportMapper;
    @Autowired
    private TauvQuestionOptionsMapper questionOptionsMapper;
    @Autowired
    private ISysCityService cityService;
    @Autowired
    private TauvInspectQuestionMapper inspectQuestionMapper;

    /**
     * 根据条件获取分页数据
     *
     * @param map
     * @return
     */
    @Override
    public Response getPageList(Map<String, Object> map, String actType) {
        Integer pageNo = 1;
        if (!StringUtils.isEmpty(map)) {
            String format = "yyyy-MM-dd";
            if (map.containsKey("page") && !"".equals(map.get("page"))) {
                pageNo = Integer.valueOf(map.getOrDefault("page", "1").toString());
            }
            String inspectTime = map.getOrDefault("inspectTime", "").toString();
            if (!StringUtils.isEmpty(inspectTime) && inspectTime.contains("~")) {
                String[] inspectTimeArr = inspectTime.split("~");
                String startTimeStr = inspectTimeArr[0];
                String endTimeStr = inspectTimeArr[1];
                if (!StringUtils.isEmpty(startTimeStr) && !StringUtils.isEmpty(endTimeStr)) {
                    startTimeStr = inspectTimeArr[0] + " 0:00:00";
                    endTimeStr = inspectTimeArr[1] + " 23:59:59";
                    map.put("startTime", startTimeStr);
                    map.put("endTime", endTimeStr);
//                    Date startDate = DateUtil.parse(startTimeStr, format);
//                    Date endDate = DateUtil.parse(endTimeStr, format);
//                    Long startDateL = startDate.getTime() / 1000;
//                    Long endDateL = endDate.getTime() / 1000;
//                    Integer startTime = startDateL.intValue();
//                    Integer endTime = endDateL.intValue();
//                    if (startTime > 0 && endTime > 0) {
//                        map.put("startTime", startTime);
//                        map.put("endTime", endTime);
//                    }
                }
            }
            String status = map.getOrDefault("status", "").toString();
            if (!StringUtils.isEmpty(status)) {
                map.put("status", status.split(","));
            }
//            //河道类型
//            if (!StringUtils.isEmpty(map.get("driverExam")) && Integer.valueOf(map.get("driverExam").toString()) > 0) {
//                map.put("driverExam", Integer.valueOf(map.get("driverExam").toString()));
//            } else {
//                map.remove("driverExam");
//            }
            // 区域
//            map = FunctionUtils.dealArea(map);
            // 区划查询范围
            if (map.containsKey("driverArea") && !StringUtils.isEmpty(map.get("driverArea"))) {
                // 区划ID
                BigInteger driverArea = BigInteger.valueOf(Long.valueOf(map.get("driverArea").toString()));
                if (map.containsKey("driverAreaType") && !StringUtils.isEmpty(map.get("driverAreaType"))) {
                    Integer driverAreaType = Integer.valueOf(map.get("driverAreaType").toString());
                    List<BigInteger> cityIds = new ArrayList<>();
                    if (driverArea != null) {
                        if (driverAreaType == 1) {
                            // 区划所有(取本级及子级区划ID)
                            cityIds = cityService.getChildCityIds(driverArea);
                            // 加入当前选中的区划
                            cityIds.add(driverArea);
                        } else {
                            // 本级河湖区划
                            cityIds.add(driverArea);
                        }
                    }
                    String cityIdsStr = org.apache.commons.lang3.StringUtils.join(cityIds.toArray(), ",");
                    String[] cityIdsList = cityIdsStr.split(",");
                    map.put("driverArea", cityIdsList);
                } else {
                    map.put("driverArea", driverArea);
                }
            } else {
                map.remove("driverArea");
            }

            //每页条数
            if (map.containsKey("pageSize") && !"".equals(map.get("pageSize")) && Integer.valueOf(map.get("pageSize").toString()) > 0) {
                pageSize = Integer.valueOf(map.get("pageSize").toString());
            }
        }
        IPage<TauvInspectDriverPicDTO> page = new Page<>(pageNo, pageSize);
        Integer adminId = ShiroUtils.getAdminId();
        boolean hasAccess = getAccess();
        if (hasAccess) {
            map.put("flightHand", adminId);
        }
        List<TauvInspectDriverPicDTO> list = inspectDriverMapper.getFilePageList(page, map);
        if (list != null) {
            TauvInspectDriverPicDTO picDTO = new TauvInspectDriverPicDTO();
            Map<Integer, String> statusList = picDTO.getStatusList();
            String format = "yyyy-MM-dd HH:mm:ss";
            for (TauvInspectDriverPicDTO driverPicDTO : list) {
                Date executionTime = driverPicDTO.getExecutionTime();
                if (!StringUtils.isEmpty(executionTime)) {
                    driverPicDTO.setFormatExecutionTime(DateUtil.format(executionTime, "yyyy-MM-dd"));
                }
                Integer status = driverPicDTO.getStatus().intValue();
                driverPicDTO.setStatusText(StringUtils.isEmpty(status) ? "" : statusList.get(status));
                Date reviewTime = driverPicDTO.getReviewTime();
                if (reviewTime != null) {
                    driverPicDTO.setFormatReviewTime(DateUtil.format(reviewTime, format));
                }
                if (!StringUtils.isEmpty(driverPicDTO.getReviewUser())) {
                    SysAdmin adminInfo = iSysAdminService.getAdminInfo(driverPicDTO.getReviewUser());
                    driverPicDTO.setFormatReviewUser(StringUtils.isEmpty(adminInfo) ? "" : adminInfo.getRealname());
                }
                //获取图片信息
                Date lastUploadTime = getFileLastUploadTime(driverPicDTO.getId(), actType);
                if (lastUploadTime != null) {
                    driverPicDTO.setLastUploadTime(DateUtil.format(lastUploadTime, "yyyy-MM-dd"));
                }
                if (actType.equals("pic")) {
                    //审核图片数量
                    Map<String, Integer> picData = getCountPicByInspectDriverId(driverPicDTO.getId());
                    driverPicDTO.setTotalNum(picData.getOrDefault("total", 0));
                    driverPicDTO.setSignNum(picData.getOrDefault("signNum", 0));
                    driverPicDTO.setUnsignNum(picData.getOrDefault("unSignNum", 0));

                    driverPicDTO.setEffectiveNum(picData.getOrDefault("effectiveNum", 0));
                    driverPicDTO.setUnEffectiveNum(picData.getOrDefault("unEffectiveNum", 0));
                    driverPicDTO.setReviewNum(picData.getOrDefault("reviewNum", 0));
                    driverPicDTO.setUnreviewNum(picData.getOrDefault("unReviewNum", 0));
                }

                if (!StringUtils.isEmpty(driverPicDTO.getDriverArea())) {
                    SysCity cityInfo = iSysCityService.getInfoById(driverPicDTO.getDriverArea());
                    driverPicDTO.setDriverAreaText(StringUtils.isEmpty(cityInfo) ? "" : cityInfo.getName());
                }
                if (hasAccess) {
                    driverPicDTO.setCanOption(1);
                } else {
                    driverPicDTO.setCanOption(0);
                }
            }
        }
        page.setRecords(list);
        return response.success(page);
    }

    /**
     * 图片上传
     *
     * @param map
     * @return
     */
    @Override
    public Response uploadPic(Map<String, Object> map) throws IOException {
        if (StringUtils.isEmpty(map)) {
            return response.failure("参数不全");
        }
        if (StringUtils.isEmpty(map.get("fileList"))) {
            return response.failure("请选择要上传的文件");
        }
        String inspectDriverIdStr = map.get("inspectDriverId").toString();
        String fileDocument = map.get("fileDocument").toString();
        List<String> fileList = (List<String>) map.get("fileList");
        if (StringUtils.isEmpty(inspectDriverIdStr)) {
            return response.failure("任务编号不能为空");
        }
        if (StringUtils.isEmpty(fileDocument)) {
            return response.failure("图片类型不能为空");
        }
        Integer inspectDriverId = Integer.valueOf(inspectDriverIdStr);
        TauvInspectDriver driverInfo = inspectDriverMapper.selectById(inspectDriverId);
        Integer inspectId = StringUtils.isEmpty(driverInfo) ? 0 : driverInfo.getInspectId();
        Calendar calendar = Calendar.getInstance();
        String year = calendar.get(Calendar.YEAR) + "";
        String month = (calendar.get(Calendar.MONTH) + 1) + "";
        String day = calendar.get(Calendar.DATE) + "";
        String destPath = uploadFolder + "/file/file/" + year + month + day + "/";
        File destPathFile = new File(destPath);
        if (!destPathFile.isDirectory()) {
            destPathFile.mkdirs();
        }
        List<Map<String, String>> list = new ArrayList<>();
        //判断同一任务、同一图片分类下是否已存在待上传的图片
        Integer num = 1;
        String numStr = "";
        for (String fileSrc : fileList) {
            fileSrc = fileSrc.replace("-thumbnail", "");
            fileSrc = fileSrc.replace(uploadUrl, uploadFolder);
            String md5 = DigestUtils.md5Hex(new FileInputStream(fileSrc));
            QueryWrapper wrapper = new QueryWrapper();
            wrapper.eq("mark", 1);
            wrapper.eq("inspect_driver_id", inspectDriverId);
            wrapper.eq("file_document", fileDocument);
            wrapper.eq("md5", md5);
            List<TauvInspectFile> fileExists = inspectFileMapper.selectList(wrapper);
            if (fileExists.size() > 0) {
                numStr += "【" + num + "】";
            }
            num++;
        }
        if (!"".equals(numStr)) {
            return response.failure("第" + numStr + "张图片已存在");
        }
        for (String fileSrc : fileList) {
            fileSrc = fileSrc.replace("-thumbnail", "");
            fileSrc = fileSrc.replace(uploadUrl, uploadFolder);
            File file = new File(fileSrc);
            Map<String, String> mapReturn = new HashMap<>(3);
            TauvInspectFile inspectFile = new TauvInspectFile();
            String originName = file.getName();
            Long size = file.length();
            String extension = originName.substring(originName.lastIndexOf(".") + 1);
            String nname = UUID.randomUUID().toString().replaceAll("-", "").substring(0, 32);
            String newName = nname + "." + extension;
            String destFileUrl = destPath + originName;
            String destNewFileUrl = destPath + newName;
            inspectFile.setInspectId(inspectId);
            inspectFile.setDate(year + month + day);
            inspectFile.setInspectDriverId(inspectDriverId);
            inspectFile.setFileDocument(fileDocument);
            inspectFile.setExtension(extension);
            inspectFile.setName(originName);
            inspectFile.setFileType(Integer.valueOf("1"));
            inspectFile.setSize(size.intValue());
            inspectFile.setFileName(originName);
            inspectFile.setType(extension);
            inspectFile.setMd5(DigestUtils.md5Hex(new FileInputStream(fileSrc)));
            mapReturn.put("code", "ok");
            FileUtil.cutGeneralFile(fileSrc, destPath);
            File destFile = new File(destFileUrl);
            File destNewFile = new File(destNewFileUrl);
            destFile.renameTo(destNewFile);
            if (ImageUtil.isImage(extension)) {
                List<Map<String, Integer>> sizeList = getCutImgSize();
                String[] scalImgArr = new String[2];
                int i = 0;
                for (Map<String, Integer> sizeL : sizeList) {
                    String scalImg = uploadFolder + nname + "_" + sizeL.get("extension") + "." + extension;
                    int width = sizeL.get("width");
                    int height = sizeL.get("height");
                    ImageUtil.thumbnailImage(destNewFile, width, height, scalImg, false);
                    scalImgArr[i] = scalImg;
                    i++;
                }
                String thumbImg = scalImgArr[0].replace(uploadFolder, "");
                String filePath = destNewFileUrl.replace(uploadFolder, "");
                inspectFile.setSrc(filePath);
                inspectFile.setOriginalImg(filePath);
                inspectFile.setCreateUser(ShiroUtils.getAdminId());
                inspectFile.setCreateTime(DateUtil.now());
                inspectFile.setThumbImg(thumbImg);
                inspectFileMapper.insert(inspectFile);
                mapReturn.put("msg", "success");
                mapReturn.put("fileUrl", uploadUrl + thumbImg);
            } else {
                mapReturn.put("code", "error");
                mapReturn.put("msg", "上传图片格式不正确");
                mapReturn.put("fileUrl", "");
                log.warn("上传图片格式不正确");
            }

            list.add(mapReturn);
        }
        return response.success(list);
    }

    /**
     * 保存标记的图片
     *
     * @param map
     * @return
     */
    @Override
    public Response savePic(Map<String, String> map) {
        if (StringUtils.isEmpty(map)) {
            return response.failure("参数不能为空");
        }
        String img = map.get("img");
        String idStr = map.get("id");
        String questionId = map.getOrDefault("questionId", "");
        String description = map.getOrDefault("description", "");

        log.warn("==上传图片");
        log.warn("接受的数据=" + img);
        String dataPrix = "";//base64格式前头
        String data = "";//实体部分数据
        if (img == null || "".equals(img)) {
            return response.failure("上传失败，上传图片数据为空");
        }
        if (StringUtils.isEmpty(idStr)) {
            return response.failure("标记文件的编号不能为空");
        }
        if (map.containsKey("description") && !"".equals(map.get("description")) && map.get("description").length() > 200) {
            return response.failure("详细描述不能超过200字");
        }
        Integer id = Integer.valueOf(idStr);
        TauvInspectFile info = getInfoById(id);
        if (StringUtils.isEmpty(info)) {
            return response.failure("数据不存在");
        }
        File originFile = new File(info.getOriginalImg());
        String originName = originFile.getName();
        String originPath = originFile.getParent();
        String[] d = img.split("base64,");
        if (d != null && d.length == 2) {
            dataPrix = d[0];
            data = d[1];
        } else {
            return response.failure("上传失败，数据不合法");
        }

        if ("data:image/jpeg;".equalsIgnoreCase(dataPrix)) {

        } else if ("data:image/x-icon;".equalsIgnoreCase(dataPrix)) {

        } else if ("data:image/gif;".equalsIgnoreCase(dataPrix)) {

        } else if ("data:image/png;".equalsIgnoreCase(dataPrix)) {

        } else {
            return response.failure("上传图片格式不合法");
        }
        String[] originNames = originName.split(".");
//        String newName = originNames[0] + "_sign" + "." + originNames[1];
        String newName = originName.replace(".", "_sign.");
        String newFilePath = uploadFolder + originPath + "/" + newName;
        BASE64Decoder decoder = new BASE64Decoder();
        try {
            byte[] b = decoder.decodeBuffer(data);
            for (int i = 0; i < b.length; i++) {
                if (b[i] < 0) {
                    b[i] += 256;
                }
            }
            OutputStream outputStream = new FileOutputStream(newFilePath);
            outputStream.write(b);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
            log.error(e.getMessage());
            return response.failure("图片上传失败");
        }
        newFilePath = newFilePath.replace(uploadFolder, "");
        TauvInspectFile inspectFile = new TauvInspectFile();
        inspectFile.setId(id);
        inspectFile.setSrc(newFilePath);
        inspectFile.setStatus(1);
        inspectFile.setUpdateTime(DateUtil.now());
        inspectFile.setUpdateUser(ShiroUtils.getAdminId());
        if (!StringUtils.isEmpty(questionId)) {
            inspectFile.setQuestionId(Integer.valueOf(questionId));
        }
        if (!StringUtils.isEmpty(description)) {
            inspectFile.setDescription(description);
        }
        inspectFileMapper.updateById(inspectFile);
        return response.success("操作成功");
    }

    /**
     * 取消标记
     *
     * @param id
     * @return
     */
    @Override
    public Response cancelMark(Integer id) {
        if (StringUtils.isEmpty(id)) {
            return response.failure("编号不存在");
        }
        TauvInspectFile info = getInfoById(id);
        if (StringUtils.isEmpty(info)) {
            return response.failure("数据不存在");
        }
        TauvInspectFile inspectFile = new TauvInspectFile();
        inspectFile.setId(id);
        inspectFile.setStatus(Integer.valueOf("2"));
        inspectFile.setSrc("");
        inspectFile.setUpdateTime(DateUtil.now());
        inspectFile.setUpdateUser(ShiroUtils.getAdminId());
        inspectFileMapper.updateById(inspectFile);
        return response.success("操作成功");
    }

    /**
     * 删除任务下面的图片
     *
     * @param id
     * @return
     */
    @Override
    public Response drop(Integer id) {
        if (StringUtils.isEmpty(id)) {
            return response.failure("编号不能为空");
        }
        TauvInspectDriver info = inspectDriverMapper.selectById(id);
        if (StringUtils.isEmpty(info)) {
            return response.failure("数据不存在");
        }
        Integer mark = 0;
//        TauvInspectDriver inspectDriver = new TauvInspectDriver();
//        inspectDriver.setMark(mark);
//        inspectDriver.setId(id);
//        inspectDriverMapper.updateById(inspectDriver);
        TauvInspectFile inspectFile = new TauvInspectFile();
        QueryWrapper<TauvInspectFile> wrapper = new QueryWrapper<>();
        wrapper.eq("inspect_driver_id", id);
        inspectFile.setMark(0);
        inspectFileMapper.update(inspectFile, wrapper);
        return response.success("操作成功");
    }

    /**
     * 根据图片编号删除数据
     *
     * @param id
     * @return
     */
    @Override
    public Response dropPic(Integer id) {
        if (StringUtils.isEmpty(id)) {
            return response.failure("编号不存在");
        }
        TauvInspectFile info = getInfoById(id);
        if (StringUtils.isEmpty(info)) {
            return response.failure("数据不存在");
        }
        TauvInspectFile inspectFile = new TauvInspectFile();
        inspectFile.setId(id);
        inspectFile.setMark(0);
        inspectFile.setUpdateTime(DateUtil.now());
        inspectFile.setUpdateUser(ShiroUtils.getAdminId());
        inspectFileMapper.updateById(inspectFile);
        return response.success("操作成功");
    }

    /**
     * 获取任务相关的图片
     *
     * @param id
     * @return
     */
    @Override
    public Response view(Integer id) {
        if (StringUtils.isEmpty(id)) {
            return response.failure("编号不存在");
        }
        TauvInspectDriver info = inspectDriverMapper.selectById(id);
        if (StringUtils.isEmpty(info)) {
            return response.failure("数据不存在");
        }
        QueryWrapper<TauvInspectFile> wrapper = new QueryWrapper<>();
        wrapper.eq("inspect_driver_id", id);
        wrapper.eq("file_type", 1);
        wrapper.eq("mark", 1);
        wrapper.select("id,src,original_img,thumb_img,status,file_document,description,question_id");
        List<Map<String, Object>> list = inspectFileMapper.selectMaps(wrapper);
        if (list != null) {
            for (Map<String, Object> map : list) {
                String status = map.get("status").toString();
                if (status.equals("1")) {
                    //已标记
                    map.put("src", uploadUrl + map.get("src"));
                } else {
                    String src = map.get("thumb_img").toString();
                    src = src.replace("_1", "_2");
                    map.put("src", uploadUrl + src);
                }

                map.put("original_img", uploadUrl + map.get("original_img"));
                map.put("thumb_img", uploadUrl + map.get("thumb_img"));
            }
        }
        return response.success(list);
    }

    /**
     * 标记已完成
     *
     * @param id
     * @return
     */
    @Override
    public Response setMarkFinish(Integer id) {
        if (StringUtils.isEmpty(id)) {
            return response.failure("编号不存在");
        }
        TauvInspectDriver info = inspectDriverMapper.selectById(id);
        if (StringUtils.isEmpty(info)) {
            return response.failure("数据不存在");
        }
        //判断该任务对应的图片是否都已标记
        QueryWrapper wrapper = new QueryWrapper();
        wrapper.eq("mark", 1);
        wrapper.ne("status", 1);
        wrapper.eq("inspect_driver_id", id);
        wrapper.eq("file_type", 1);
        List<TauvInspectFile> fileList = inspectFileMapper.selectList(wrapper);
        if (fileList.size() > 0) {
            return response.failure("您还有【" + fileList.size() + "】张图片未标记");
        }
        TauvInspectDriver inspectDriver = new TauvInspectDriver();
        inspectDriver.setStatus(Integer.valueOf("5"));
        inspectDriver.setId(id);
        inspectDriver.setUpdateTime(DateUtil.now());
        inspectDriver.setUpdateUser(ShiroUtils.getAdminId());
        inspectDriverMapper.updateById(inspectDriver);
        return response.success("操作成功");
    }

    @Override
    public String downFile(File file) {
        if (file.exists()) {
            HttpServletResponse response = FunctionUtils.getResponse();
            String fileName = file.getName();
            response.setHeader("content_type", "application/octet-stream");
            response.setContentType("application/octet-stream");
            //下载文件能正常显示中文
            //response.setHeader("Content-Disposition", "attachment;filename=" + URLEncoder.encode(fileName,"UTF-8"));
            byte[] buffer = new byte[1024];
            FileInputStream fis = null;
            BufferedInputStream bis = null;
            try {
                fis = new FileInputStream(file);
                bis = new BufferedInputStream(fis);
                OutputStream os = response.getOutputStream();
                int i = bis.read(buffer);
                while (i != -1) {
                    os.write(buffer, 0, i);
                    i = bis.read(buffer);
                }
                return "success";
            } catch (Exception e) {
                log.error(e.getMessage());
                e.printStackTrace();
                return "failed";
            } finally {
                if (bis != null) {
                    try {
                        bis.close();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
                if (fis != null) {
                    try {
                        fis.close();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            }
        } else {
            return "";
        }
    }

    /**
     * 图片分类
     *
     * @return
     */
    @Override
    public Response getDocumentList() {
        TauvInspectFile inspectFile = new TauvInspectFile();
        return response.success(inspectFile.getFileDocumentList());
    }

    /**
     * 复核图片查看
     *
     * @param id
     * @return
     */
    @Override
    public Response getReviewPic(Integer id) {
        if (StringUtils.isEmpty(id)) {
            return response.failure("数据不存在");
        }
        TauvInspectDriver info = inspectDriverMapper.selectById(id);
        if (StringUtils.isEmpty(info)) {
            return response.failure("数据不存在");
        }
        TauvInspectFile inspectFile = new TauvInspectFile();
        Map<String, String> documentList = inspectFile.getFileDocumentList();
        Set<String> setList = documentList.keySet();
        List<Map<String, Object>> dataList = new ArrayList<>();
        for (String doc : setList) {
            QueryWrapper<TauvInspectFile> wrapper = new QueryWrapper<>();
            wrapper.eq("inspect_driver_id", id);
            wrapper.eq("file_document", doc);
            wrapper.eq("mark", 1);
            wrapper.select("id,src,original_img,thumb_img,is_effective,location,baidu_address,gaode_address,create_time,question_id,description");
            List<Map<String, Object>> list = inspectFileMapper.selectMaps(wrapper);
            if (list != null) {
                for (Map<String, Object> mapInfo : list) {
                    if (!StringUtils.isEmpty(mapInfo.get("src"))) {
                        mapInfo.put("src", uploadUrl + mapInfo.get("src"));
                    }
                    if (!StringUtils.isEmpty(mapInfo.get("original_img"))) {
                        mapInfo.put("original_img", uploadUrl + mapInfo.get("original_img"));
                    }
                    if (!StringUtils.isEmpty(mapInfo.get("thumb_img"))) {
                        mapInfo.put("thumb_img", uploadUrl + mapInfo.get("thumb_img"));
                    }
                    if (!StringUtils.isEmpty(mapInfo.get("question_id"))) {
                        TauvQuestionOptions questionInfo = questionOptionsMapper.selectById(Integer.valueOf(mapInfo.get("question_id").toString()));
                        if (questionInfo != null) {
                            mapInfo.put("question", questionInfo.getContent());
                        }
                    }
                    if (!StringUtils.isEmpty(mapInfo.get("baidu_address"))) {
                        mapInfo.put("location", mapInfo.get("baidu_address"));
                    } else if (!StringUtils.isEmpty(mapInfo.get("gaode_address"))) {
                        mapInfo.put("location", mapInfo.get("gaode_address"));
                    } else {
                        mapInfo.put("location", mapInfo.getOrDefault("location", ""));
                    }
                    mapInfo.remove("baidu_address");
                    mapInfo.remove("gaode_address");
                }
            }
            Map<String, Object> dataMap = new HashMap<>();
            dataMap.put("name", documentList.get(doc));
            dataMap.put("data", list);
            dataList.add(dataMap);
        }
        return response.success(dataList);
    }

    /**
     * 复核图片保存
     *
     * @param list
     * @return
     */
    @Override
    public Response reviewPic(List<Map<String, String>> list) {
        if (StringUtils.isEmpty(list)) {
            return response.failure("参数不存在");
        }
        String msg = "";
        Integer inspectDriverId = 0;
        for (Map<String, String> map : list) {
            if (StringUtils.isEmpty(map)) {
                msg = "参数不存在";
                break;
            }
            String idStr = map.getOrDefault("id", "");
            //1有效 2无效
            String effective = map.getOrDefault("effective", "");
            if (!"1".equals(effective) && !"2".equals(effective) && !"0".equals(effective)) {
                msg = "标记的状态值不存在";
                break;
            }
            Integer id = Integer.valueOf(idStr);
            TauvInspectFile info = getInfoById(id);
            if (StringUtils.isEmpty(info)) {
                msg = "编号为" + idStr + "不存在";
                break;
            }
            inspectDriverId = info.getInspectDriverId();
            if (Integer.valueOf(effective) > 0) {
                TauvInspectFile inspectFile = new TauvInspectFile();
                inspectFile.setIsReview(Integer.valueOf("1"));
                inspectFile.setIsEffective(Integer.valueOf(effective));
                inspectFile.setId(id);
                inspectFileMapper.updateById(inspectFile);
            }
        }
        if (!StringUtils.isEmpty(msg)) {
            return response.failure(msg);
        }

        //巡检任务状态变更为"复核中"
        TauvInspectDriver driver = inspectDriverMapper.selectById(inspectDriverId);
        driver.setId(inspectDriverId);
        driver.setStatus(Integer.valueOf("5"));
        driver.setReviewUser(ShiroUtils.getAdminId());
        driver.setReviewTime(DateUtil.now());
        inspectDriverMapper.updateById(driver);
        return response.success("复核成功");
    }

    /**
     * 复核完成
     *
     * @param id
     * @return
     */
    @Override
    public Response reviewFinish(Integer id) {
        if (StringUtils.isEmpty(id)) {
            return response.failure("数据不存在");
        }
        TauvInspectDriver info = inspectDriverMapper.selectById(id);
        if (StringUtils.isEmpty(info)) {
            return response.failure("数据不存在");
        }
        info.setStatus(6);
        info.setReviewTime(DateUtil.now());
        info.setReviewUser(ShiroUtils.getAdminId());
        inspectDriverMapper.updateById(info);

        //生成“待生成”报告
        QueryWrapper wrapper = new QueryWrapper();
        wrapper.eq("mark", 1);
        wrapper.eq("inspect_no", info.getInspectNo());
        wrapper.eq("num", info.getNum());
        TauvReport exist = reportMapper.selectOne(wrapper);
        if (!StringUtils.isEmpty(exist)) {
            return response.failure("报告已经生成过了");
        }
        TauvInspectDriver inspectDriver = inspectDriverMapper.selectById(id);
        TauvReport report = new TauvReport();
        report.setInspectId(inspectDriver.getInspectId());
        report.setInspectDriverId(id);
        report.setInspectNo(inspectDriver.getInspectNo());
        report.setDriverName(inspectDriver.getDriverName());
        report.setDriverArea(inspectDriver.getDriverArea());
        report.setDriverStart(inspectDriver.getDriverStart());
        report.setDriverEnd(inspectDriver.getDriverEnd());
        report.setInspectLength(inspectDriver.getDriverLength().toString());
        report.setInspectTime(inspectDriver.getExecutionTime());
        report.setFlightHand(inspectDriver.getFlightHand());
        report.setCreateTime(DateUtil.now());
        report.setCreateUser(ShiroUtils.getAdminId());
        reportMapper.insert(report);

        // 问题数据入库
        dealQuestionData(info);
        return response.success("操作成功");
    }

    /**
     * 根据编号获取数据
     *
     * @param id
     * @return
     */
    @Override
    public TauvInspectFile getInfoById(Integer id) {
        return inspectFileMapper.selectById(id);
    }


    /**
     * 文件下载
     *
     * @param ids
     * @return
     */
    @Override
    public File getDownloadFileByIds(String ids) {
        if (StringUtils.isEmpty(ids)) {
            return null;
        }
        String[] idsList = ids.split(",");
        Integer[] idList = (Integer[]) ConvertUtils.convert(idsList, Integer.class);
        List<TauvInspectFile> list = inspectFileMapper.getListByInspectDriverIds(idList);
        List<Map<String, Object>> fileList = new ArrayList<>();
        if (list != null) {
            for (TauvInspectFile child : list) {
                String fileUrl = uploadFolder + child.getOriginalImg();
                File file = new File(fileUrl);
                if (!file.exists()) {
                    continue;
                }
                Map<String, Object> map = new HashMap<>();
                map.put("folder", child.getName());
                map.put("file", file);
                fileList.add(map);
            }
        }
        File downFile;
        try {
            String fileName = FunctionUtils.getTimeNameByType("");
            downFile = FileUtil.getZipFile(fileList, uploadFolder + "/temp/" + fileName + ".zip");
        } catch (IOException e) {
            log.error(e.getMessage());
            e.printStackTrace();
            downFile = null;
        }
        return downFile;
    }

    /**
     * 获取复核有效图片的数量
     *
     * @param questionId
     * @param inspectDriverId
     * @return
     */
    @Override
    public Integer getReviewNumByInspectDriverId(Integer questionId, Integer inspectDriverId) {
        QueryWrapper<TauvInspectFile> wrapper = new QueryWrapper<>();
        wrapper.eq("inspect_driver_id", inspectDriverId);
        wrapper.eq("question_id", questionId);
        wrapper.eq("is_review", 1);
        wrapper.eq("is_effective", 1);
        wrapper.eq("mark", 1);
        return inspectFileMapper.selectCount(wrapper);
    }

    /**
     * 根据河道任务编号获取复核数据
     *
     * @param inspectDriverId
     * @return
     */
    @Override
    public List<Map<String, Object>> getReviewDataByInspectDriverId(Integer inspectDriverId) {
        QueryWrapper<TauvInspectFile> wrapper = new QueryWrapper<>();
        wrapper.eq("inspect_driver_id", inspectDriverId);
        wrapper.eq("file_type", 1);
        wrapper.eq("is_review", 1);
        wrapper.eq("is_effective", 1);
        wrapper.eq("mark", 1);
        wrapper.select("id,location,latitude,longitude,description,src,original_img,question_id,status,file_document,baidu_latitude,baidu_longitude,baidu_address," +
                "gaode_latitude,gaode_longitude,gaode_address");
        return inspectFileMapper.selectMaps(wrapper);
    }

    @Override
    public List<Map<String, Object>> getReviewDataByInspectDriverIdAndFileDocument(Integer inspectDriverId, String fileDocument) {
        QueryWrapper<TauvInspectFile> wrapper = new QueryWrapper<>();
        wrapper.eq("inspect_driver_id", inspectDriverId);
        wrapper.eq("file_document", fileDocument);
        wrapper.eq("status", 1);
        wrapper.eq("file_type", 1);
        wrapper.eq("is_review", 1);
        wrapper.eq("is_effective", 1);
        wrapper.eq("mark", 1);
        wrapper.select("id,location,latitude,longitude,description,src,original_img,question_id,status");
        return inspectFileMapper.selectMaps(wrapper);
    }

    /**
     * 根据任务河道编号获取问题数量
     *
     * @param inspectDriverId
     * @return
     */
    @Override
    public Integer getTotalFileByInspectDriverId(Integer inspectDriverId) {
        Integer b = 1;
        QueryWrapper<TauvInspectFile> wrapper = new QueryWrapper<>();
        wrapper.eq("is_review", b);
        wrapper.eq("is_effective", b);
        wrapper.eq("file_type", b);
        wrapper.eq("status", b);
        wrapper.ne("latitude", "");
        wrapper.eq("inspect_driver_id", inspectDriverId);
        return inspectFileMapper.selectCount(wrapper);
    }

    /**
     * 根据任务河道编号获取坐标
     *
     * @param inspectDriverId
     * @return
     */
    @Override
    public TauvInspectFile getInfoByInspectDriverId(Integer inspectDriverId) {
        Integer b = 1;
        QueryWrapper<TauvInspectFile> wrapper = new QueryWrapper<>();
        wrapper.eq("is_review", b);
        wrapper.eq("is_effective", b);
        wrapper.eq("file_type", b);
        wrapper.eq("status", b);
        wrapper.ne("latitude", "");
        wrapper.eq("inspect_driver_id", inspectDriverId);
        wrapper.last("limit 1");
        return inspectFileMapper.selectOne(wrapper);
    }

    /**
     * 根据任务河道编号获取所有数据
     *
     * @param inspectDriverId
     * @return
     */
    @Override
    public List<TauvInspectFile> getListByInspectDriverId(Integer inspectDriverId) {
        Integer b = 1;
        QueryWrapper<TauvInspectFile> wrapper = new QueryWrapper<>();
        wrapper.eq("is_review", b);
        wrapper.eq("is_effective", b);
        wrapper.eq("file_type", b);
        wrapper.eq("status", b);
        wrapper.ne("latitude", "");
        wrapper.eq("inspect_driver_id", inspectDriverId);
        return inspectFileMapper.selectList(wrapper);
    }

    /**
     * 根据河道编号获取河道类型下问题图片的数量
     *
     * @param driverArea
     * @param inspectDriverId
     * @param inspectTime
     * @return
     */
    @Override
    public List<Map<String, Object>> getNumByFileDocument(String driverArea, Integer inspectDriverId, Integer inspectTime, Integer endTime) {
//        Byte bDriverExam = Byte.valueOf(driverExam);
        String[] driverAreaList = StringUtils.isEmpty(driverArea) ? null : driverArea.split(",");
        if (inspectTime == 0) {
            inspectTime = 0;
        }
        return inspectFileMapper.getNumByFileDocument(driverAreaList, inspectDriverId, inspectTime, endTime);
    }

    /**
     * 根据编号获取图片统计信息
     *
     * @param InspectDriverId
     * @return
     */
    private Map<String, Integer> getCountPicByInspectDriverId(Integer InspectDriverId) {
        QueryWrapper<TauvInspectFile> wrapper = new QueryWrapper<>();
        wrapper.eq("inspect_driver_id", InspectDriverId);
        wrapper.eq("file_type", 1);
        wrapper.eq("mark", 1);
        List<TauvInspectFile> list = inspectFileMapper.selectList(wrapper);
        Integer signNum = 0;
        Integer reviewNum = 0;
        Integer effectiveNum = 0;
        if (list != null) {
            for (TauvInspectFile file : list) {
                if ("1".equals(file.getStatus().toString())) {
                    signNum++;
                }
                if ("1".equals(file.getIsReview().toString())) {
                    reviewNum++;
                }
                if ("1".equals(file.getIsEffective().toString())) {
                    effectiveNum++;
                }
            }
        }
        Integer total = list.size();
        Integer unSignNum = total - signNum;
        Integer unReviewNum = total - reviewNum;
        Integer unEffectiveNum = reviewNum - effectiveNum;
        Map<String, Integer> map = new HashMap<>();
        map.put("total", total);
        map.put("signNum", signNum);
        map.put("unSignNum", unSignNum);
        map.put("reviewNum", reviewNum);
        map.put("unReviewNum", unReviewNum);
        map.put("effectiveNum", effectiveNum);
        map.put("unEffectiveNum", unEffectiveNum);
        return map;
    }

    /**
     * 根据编号获取文件或图片的上次修改时间
     *
     * @param inspectDriverId
     * @param type
     * @return
     */
    private Date getFileLastUploadTime(Integer inspectDriverId, String type) {
        QueryWrapper<TauvInspectFile> wrapper = new QueryWrapper<>();
        wrapper.eq("inspect_driver_id", inspectDriverId);
        if ("pic".equals(type)) {
            wrapper.eq("file_type", 1);
        } else if ("video".equals(type)) {
            wrapper.eq("file_type", 2);
        }
        wrapper.eq("mark", 1);
        wrapper.orderByDesc("id");
        wrapper.last("limit 1");
        TauvInspectFile inspectFile = inspectFileMapper.selectOne(wrapper);
        if (StringUtils.isEmpty(inspectFile)) {
            return null;
        }
//        Integer lastUploadTime = inspectFile.getCreateTime();
//        return FunctionUtils.formatTime(lastUploadTime, "yyyy-MM-dd HH:mm:ss");
        return inspectFile.getCreateTime();
    }

    /**
     * 判断用户是否拥有权限
     *
     * @return
     */
    private boolean getAccess() {
        boolean flag = false;
        SysAdmin adminInfo = ShiroUtils.getAdminInfo();
        String authGroup = adminInfo.getAuthGroup();//用户所在的组
        List<SysDict> list = iSysDictService.getListByTypeId(11);
        String[] authGroupArr = authGroup.split(",");
        if (list != null) {
            for (SysDict sysDict : list) {
                String value = sysDict.getValue();
                for (String auth : authGroupArr) {
                    if (value.equals(auth)) {
                        flag = true;
                        break;
                    }
                }
                if (flag) {
                    break;
                }
            }
        }
        return flag;
    }

    /**
     * 切图尺寸
     *
     * @return
     */
    private List<Map<String, Integer>> getCutImgSize() {
        List<Map<String, Integer>> list = new ArrayList<>();
        Map<String, Integer> map = new HashMap<>(3);
        map.put("width", 100);
        map.put("height", 100);
        map.put("extension", 1);
        list.add(map);
        map = new HashMap<>(3);
        map.put("width", 650);
        map.put("height", 365);
        map.put("extension", 2);
        list.add(map);
        return list;
    }

    /**
     * 根据任务河道Id和问题ID获取数据
     *
     * @param inspectDriverId
     * @param questionId
     * @return
     */
    @Override
    public TauvInspectFile getInfoByDriverIdAndQuestionId(Integer inspectDriverId, Integer questionId) {
        QueryWrapper wrapper = new QueryWrapper();
        wrapper.eq("mark", 1);
        wrapper.eq("inspect_driver_id", inspectDriverId);
        wrapper.eq("question_id", questionId);
        TauvInspectFile fileInfo = getOne(wrapper);
        return fileInfo;
    }

    @Override
    public Response getDetailById(Integer fileId) {
        TauvInspectFileDataVo inspectFileDataVo = new TauvInspectFileDataVo();
        TauvInspectFile inspectFile = getInfoById(fileId);
        if (inspectFile == null) {
            return response.failure("问题数据不存在!");
        }
        inspectFileDataVo.setId(fileId);
        inspectFileDataVo.setInspectDriverId(inspectFile.getInspectDriverId());
        if (inspectFile.getThumbImg() != null && inspectFile.getThumbImg() != "") {
            String path = inspectFile.getThumbImg().replace("_1", "_2");
            inspectFileDataVo.setFilePath(uploadUrl + path);
        }
        if (inspectFile.getOriginalImg() != null && inspectFile.getOriginalImg() != "") {
            inspectFileDataVo.setOriginImg(uploadUrl + inspectFile.getOriginalImg());
        }

        TauvInspectDriver inspectDriver = inspectDriverMapper.selectById(inspectFile.getInspectDriverId());
        if (inspectDriver != null) {
            inspectFileDataVo.setDriverName(inspectDriver.getDriverName());
            inspectFileDataVo.setExecutionTime(inspectDriver.getExecutionTime());
            String cityText = iSysCityService.getCityName(inspectDriver.getDriverArea());
            inspectFileDataVo.setDriverAreaName(cityText);
            QueryWrapper wrapper = new QueryWrapper();
            wrapper.eq("inspect_driver_id", inspectDriver.getId());
            wrapper.eq("mark", 1);
            wrapper.eq("status", 3);
            wrapper.last("limit 1");
            TauvReport report = reportMapper.selectOne(wrapper);
            if (report != null) {
                inspectFileDataVo.setReportId(report.getId());
            }
        }
        TauvQuestionOptions questionOptions = questionOptionsMapper.selectById(inspectFile.getQuestionId());
        if (questionOptions != null) {
            Map<Integer, String> categoryList = questionOptions.getCategoryList();
            String categoryText = !StringUtils.isEmpty(categoryList.get(questionOptions.getCategory())) ? categoryList.get(questionOptions.getCategory()) : "";
            inspectFileDataVo.setCategoryText(categoryText);
            Map<Integer, String> typeList = questionOptions.getTypeList();
            String typeText = !StringUtils.isEmpty(typeList.get(questionOptions.getType())) ? typeList.get(questionOptions.getType()) : "";
            inspectFileDataVo.setQuestionTypeText(typeText);
            inspectFileDataVo.setQuestionContent(questionOptions.getContent());
        }

        return response.success(inspectFileDataVo);
    }

    /**
     * 根据巡检任务ID获取航拍图片列表
     *
     * @param inspectDriverId 巡检任务ID
     * @return
     */
    @Override
    public List<TauvInspectFile> getInspectFileListByInspectDriverId(Integer inspectDriverId) {
        QueryWrapper<TauvInspectFile> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("inspect_driver_id", inspectDriverId);
        queryWrapper.eq("is_review", 1);
        queryWrapper.eq("is_effective", 1);
        queryWrapper.eq("status", 1);
        queryWrapper.eq("mark", 1);
        List<TauvInspectFile> inspectFileList = inspectFileMapper.selectList(queryWrapper);
        return inspectFileList;
    }

    /**
     * 问题管理数据处理
     *
     * @param inspectDriver
     */
    private void dealQuestionData(TauvInspectDriver inspectDriver) {
        QueryWrapper wrapper = new QueryWrapper();
        wrapper.eq("mark", 1);
        wrapper.eq("inspect_driver_id", inspectDriver.getId());
        List<TauvInspectQuestion> questionList = inspectQuestionMapper.selectList(wrapper);
        if (questionList.isEmpty()) {
            wrapper.eq("is_review", 1);
            wrapper.eq("is_effective", 1);
            wrapper.eq("status", 1);
            List<TauvInspectFile> fileList = list(wrapper);
            if (fileList.size() > 0) {
                for (TauvInspectFile item : fileList) {
                    TauvInspectQuestion question = new TauvInspectQuestion();
                    question.setInspectDriverId(inspectDriver.getId());
                    question.setInspectFileId(item.getId());
                    question.setQuestionNo(createQuestionNo());
                    question.setQuestionId(item.getQuestionId());
                    question.setCreateUser(ShiroUtils.getAdminId());
                    question.setCreateTime(DateUtil.now());
                    inspectQuestionMapper.insert(question);
                }
            }
        }
    }

    /**
     * 创建问题编号
     *
     * @return
     */
    private String createQuestionNo() {
        Calendar date = Calendar.getInstance();
        String year = String.valueOf(date.get(Calendar.YEAR)).substring(2);
        String month = String.format("%02d", date.get(Calendar.MONTH) + 1);
        String code = "10" + year + month + (int) ((Math.random() * 9 + 1) * 100000);
        return code;
    }
}
