package com.taauav.admin.service.impl;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.taauav.admin.dto.TauvInspectPhotoDTO;
import com.taauav.admin.vo.TauvInspectPhotoVo;
import com.taauav.common.bean.Response;
import com.taauav.common.core.mps.BaseQuery;
import com.taauav.common.service.impl.BaseServiceImpl;
import com.taauav.common.util.DateUtil;
import com.taauav.common.util.ShiroUtils;
import com.taauav.common.util.StringUtils;
import org.springframework.stereotype.Service;
import com.taauav.admin.mapper.TauvInspectPhotoMapper;
import com.taauav.admin.entity.TauvInspectPhoto;
import com.taauav.admin.service.ITauvInspectPhotoService;

import javax.annotation.Resource;

/**
 * 巡检正摄图Service业务层处理
 *
 * @author daixiantong
 * @date 20200518
 */
@Service
public class TauvInspectPhotoServiceImpl extends BaseServiceImpl<TauvInspectPhotoMapper, TauvInspectPhoto> implements ITauvInspectPhotoService
{
    @Resource
    private Response response;

    /**
     * 自定义分页列表
     * @param inspectPhotoDTO
     * @param query
     * @return
     */
    @Override
    public Response selectPhotoPage(TauvInspectPhotoDTO inspectPhotoDTO, BaseQuery query) {
        IPage<TauvInspectPhoto> page = new Page<>(query.getPage(), query.getPageSize());
        IPage<TauvInspectPhotoVo> list = baseMapper.selectPhotoPage(page, inspectPhotoDTO);
        return response.success(list);
    }

    @Override
    public Response editPhoto(TauvInspectPhoto inspectPhoto) {
        if (inspectPhoto == null || inspectPhoto.getId() == null) {
            return response.failure("id不能为空");
        }
        if (StringUtils.isEmpty(inspectPhoto.getPhotoUrl())) {
            return response.failure("请先上传正摄图");
        }
        inspectPhoto.setUploadTime(DateUtil.now());
        inspectPhoto.setUploadUser(ShiroUtils.getAdminId());
        updateById(inspectPhoto);
        return response.success("操作成功");
    }
}
