package com.taauav.admin.service.impl;


import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.taauav.common.bean.Response;
import com.taauav.common.service.impl.BaseServiceImpl;
import com.taauav.common.util.DateUtil;
import com.taauav.common.util.ShiroUtils;
import org.springframework.stereotype.Service;
import com.taauav.admin.mapper.TauvWaterWarnMapper;
import com.taauav.admin.entity.TauvWaterWarn;
import com.taauav.admin.service.ITauvWaterWarnService;

import javax.annotation.Resource;

/**
 * 水质预警Service业务层处理
 *
 * @author daixiantong
 * @date 20200514
 */
@Service
public class TauvWaterWarnServiceImpl extends BaseServiceImpl<TauvWaterWarnMapper, TauvWaterWarn> implements ITauvWaterWarnService
{
    @Resource
    private Response response;

    /**
     * 取消预警
     * @param ids
     * @return
     */
    @Override
    public Response cancelWarn(String ids) {
        UpdateWrapper updateWrapper = new UpdateWrapper();
        updateWrapper.in("id", ids);
        updateWrapper.eq("mark", 1);
        updateWrapper.set("status", 3);
        updateWrapper.set("update_user", ShiroUtils.getAdminId());
        updateWrapper.set("update_time", DateUtil.now());
        Boolean res = update(updateWrapper);
        if (!res) {
            return response.failure("操作失败");
        }
        return response.success("操作成功");
    }

    /**
     * 删除预警数据
     * @param ids
     * @return
     */
    @Override
    public Response dropWarn(String ids) {
        UpdateWrapper updateWrapper = new UpdateWrapper();
        updateWrapper.in("id", ids);
        updateWrapper.set("mark", 0);
        Boolean result = update(updateWrapper);
        if (!result) {
            return response.failure("删除失败");
        }
        return response.success("删除成功");
    }
}
