package com.taauav.admin.validate;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.hibernate.validator.constraints.Length;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.DecimalMin;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.util.Date;

/**
 * @author dyg
 * @date 2019/11/22
 * @desc 执行任务数据验证
 */
@Data
public class ExecuteTask {
    @NotNull(message = "任务编号不能为空")
    private Integer id;

    /**
     * 执行时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date executionTime;

    /**
     * 天气
     */
    @Length(max = 20, message = "天气长度最多为20")
    private String weather;

    /**
     * 风向
     */
    @Length(max = 20, message = "风向长度最多为20")
    private String wind;

    /**
     * 温度
     */
    @Length(max = 20, message = "温度长度最多为20")
    private String temperature;

    /**
     * 飞行速度
     */
    @Length(max = 9, message = "飞行速度长度最多为20")
    private String flightSpeed;

    /**
     * 飞行高度
     */
    @Length(max = 9, message = "飞行高度长度最多为20")
    private String flightHeight;

    /**
     * 飞行时间
     */
    @Length(max = 9, message = "飞行时间长度最多为20")
    private String flightTime;

    @Length(max = 200, message = "备注不能超过200个字符")
    private String remark;
}
