package com.taauav.admin.vo;

import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.math.BigInteger;

/**
 * 河流列表Vo
 */
@Data
public class TauvDriverListVo {

    /**
     * 河流ID
     */
    private Integer id;

    /**
     * 河流ID
     */
    private Integer driverId;

    /**
     * 河道编码
     */
    private String driverSn;

    /**
     * 河道名称
     */
    private String name;

    /**
     * 河道类型：1河流 2水库 3湖泊 4重点塘坝
     */
    private Integer type;

    /**
     * 河道层级:3县/区 4镇 5村
     */
    private Integer level;

    /**
     * 河长ID
     */
    private Integer driverManager;

    /**
     * 河长名称
     */
    private String driverManagerName;

    /**
     * 河道长度(单位：km)
     */
    private String length;

    /**
     * 起点
     */
    private String startPoint;

    /**
     * 终点
     */
    private String endPoint;

    /**
     * 区划ID
     */
    private BigInteger driverArea;

    /**
     * 区划名称
     */
    private String driverAreaName;

    /**
     * 备注
     */
    private String note;

}
