package com.taauav.admin.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.taauav.admin.entity.TauvInspectQuestion;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigInteger;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * 问题管理请求结果实体类
 *
 * @author daixiantong
 * @date 2020-05-18
 */
@Data
public class TauvInspectQuestionVo extends TauvInspectQuestion {

    /**
     * 区划id
     */
    private BigInteger driverArea;

    /**
     * 区划名称
     */
    private String areaName;

    /**
     * 河湖名称
     */
    private String driverName;

    /**
     * 问题缩略图地址
     */
    private String imgUrl;

    /**
     * 巡检时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date inspectTime;

    /**
     * 问题类型
     */
    private String questionType;

    /**
     * 问题状态描述
     */
    private String statusText;

    /**
     * 位置信息
     */
    private String location;

    /**
     * 状态数组
     * @return
     */
    public Map<String, String> statusList() {
        Map<String, String> map = new HashMap<>();
        map.put("1", "待指派");
        map.put("2", "待处理");
        map.put("3", "已完成");
        return map;
    }
}
