package com.taauav.common.web;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import java.util.List;
import java.util.stream.Collectors;

public abstract class BaseWrapper<E,V> {

    public BaseWrapper(){}

    public abstract V entityVO(E entity);

    public List<V> listVO(List<E> list) {
        return list.stream().map(this::entityVO).collect(Collectors.toList());
    }

    public IPage<V> pageVO(IPage<E> pages) {
        List<V> records = this.listVO(pages.getRecords());
        IPage<V> pageVO = new Page<>(pages.getCurrent(), pages.getSize(), pages.getTotal());
        pageVO.setRecords(records);
        return pageVO;
    }
}
