package com.taauav.front.controller;

import com.taauav.admin.entity.TauvInspect;
import com.taauav.admin.service.ITauvInspectService;
import com.taauav.common.bean.Response;
import com.taauav.common.constant.PermissionConstants;
import com.taauav.front.service.IUserInspectService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.validation.FieldError;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;
import java.util.List;

/**
 * 巡检任务
 */
@RestController
@RequestMapping("/front/inspect")
public class UserInspectController {

    @Autowired
    private IUserInspectService userInspectService;
    @Autowired
    private Response response;

    private static final String controllerName = "inspect";

    @PostMapping("/addTask")
    @RequiresPermissions(controllerName + ":" + PermissionConstants.ADD_PERMISSION)
    public Response addTask(@RequestBody @Valid TauvInspect inspect, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            List<FieldError> errorList = bindingResult.getFieldErrors();
            String msg = bindingResult.getFieldError().getDefaultMessage();
            return response.failure(msg);
        }
        return userInspectService.addTask(inspect);
    }

}
