package com.taauav.front.controller;


import com.taauav.common.bean.Response;
import com.taauav.common.constant.PermissionConstants;
import com.taauav.front.query.UserInspectDriverQuery;
import com.taauav.front.service.IUserAdminService;
import com.taauav.front.service.IUserInspectDriverService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 * 巡检任务 前端控制器
 * </p>
 *
 * @author 鲲鹏
 * @since 2020-05-14
 */
@RestController
@RequestMapping("/front/inspectDriver")
public class UserInspectDriverController extends FrontBaseController {

    @Autowired
    private IUserInspectDriverService inspectDriverService;

    private static final String controllerName = "inspectDriver";

    /**
     * 获取巡检任务列表
     *
     * @param map
     * @return
     */
    @PostMapping("/index")
    public Response index(@RequestBody(required = false) Map<String, Object> map) {
        if (map == null) {
            map = new HashMap<>();
        }
        String status = "status";
        if (map.containsKey(status) && !"".equals(map.get(status))) {
            map.put("status", Integer.valueOf(map.get(status).toString()));
        } else {
            map.put("status", new Integer[]{2, 3, 4, 5, 6});
        }
        return inspectDriverService.getList(map);
    }

    /**
     * 任务详情
     */
    @GetMapping("/detail")
//    @RequiresPermissions(controllerName + ":" + PermissionConstants.VIEW_PERMISSION)
    public Response detail(@RequestBody @RequestParam("id") Integer id) {
        return inspectDriverService.detail(id);
    }
}
