package com.taauav.front.controller;


import com.taauav.common.bean.Response;
import com.taauav.front.entity.UserNotice;
import com.taauav.front.query.UserNoticeQuery;
import com.taauav.front.service.IUserNoticeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.taauav.front.controller.FrontBaseController;

/**
 * <p>
 * 通知公告表 前端控制器
 * </p>
 *
 * @author 鲲鹏
 * @since 2020-05-14
 */
@RestController
@RequestMapping("/front/usernotice")
public class UserNoticeController extends FrontBaseController {

    @Autowired
    private IUserNoticeService noticeService;

    /**
     * 获取通知公告列表
     *
     * @param query 查询条件
     * @return
     */
    @PostMapping("/index")
    public Response index(@RequestBody UserNoticeQuery query) {
        return noticeService.getNoticeList(query);
    }

    /**
     * 添加通知公告
     *
     * @param entity 实体对象
     * @return
     */
    @PostMapping("/add")
    public Response add(@RequestBody UserNotice entity) {
        return noticeService.add(entity);
    }

    /**
     * 编辑通知公告
     *
     * @param entity 实体对象
     * @return
     */
    @PostMapping("/edit")
    public Response edit(@RequestBody UserNotice entity) {
        return noticeService.edit(entity);
    }

    /**
     * 获取详情信息
     *
     * @param noticeId 记录ID
     * @return
     */
    @GetMapping("/info")
    public Response info(Integer noticeId) {
        return noticeService.info(noticeId);
    }

    /**
     * 删除通知公告
     *
     * @param noticeId 通知公告ID
     * @return
     */
    @PostMapping("/delete")
    public Response delete(Integer noticeId) {
        return noticeService.delete(noticeId);
    }

}
