package com.taauav.front.controller;


import com.taauav.common.bean.Response;
import com.taauav.front.query.UserWaterAlarmQuery;
import com.taauav.front.service.IUserWaterAlarmService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.taauav.front.controller.FrontBaseController;

/**
 * <p>
 * 水质报警 前端控制器
 * </p>
 *
 * @author 鲲鹏
 * @since 2020-05-15
 */
@RestController
@RequestMapping("/front/wateralarm")
public class UserWaterAlarmController extends FrontBaseController {

    @Autowired
    private IUserWaterAlarmService userWaterAlarmService;

    /**
     * 获取水质报警列表
     *
     * @param query 查询条件
     * @return
     */
    @PostMapping("/index")
    public Response index(@RequestBody UserWaterAlarmQuery query) {
        return userWaterAlarmService.getList(query);
    }

    /**
     * 获取水质报警详情
     *
     * @param id 记录ID
     * @return
     */
    @GetMapping("/detail")
    public Response detail(Integer id) {
        return userWaterAlarmService.detail(id);
    }

    /**
     * 取消报警
     *
     * @param ids 记录ID
     * @return
     */
    @PostMapping("/cancel")
    public Response cancel(String ids) {
        return userWaterAlarmService.cancel(ids);
    }

}
