package com.taauav.front.entity;

import java.time.LocalDateTime;

import com.taauav.common.domain.Entity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 外部用户角色表
 * </p>
 *
 * @author 鲲鹏
 * @since 2020-05-14
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
public class UserAuthGroup extends Entity {

    private static final long serialVersionUID = 1L;

    /**
     * 用户组中文名称
     */
    private String name;

    /**
     * 数据权限：1查看自己区划数据 2查看所有区划数据 3查看指定区划数据
     */
    private Integer authData;

    /**
     * auth_data=3时的个性化区划
     */
    private String driverArea;

    /**
     * 用户组拥有的规则id，多个规则","隔开
     */
    private String rules;

    /**
     * 备注
     */
    private String remark;

    /**
     * 排序
     */
    private Integer sort;

}
