package com.taauav.front.entity;

import java.time.LocalDateTime;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.taauav.common.domain.Entity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

/**
 * <p>
 * 通知公告表
 * </p>
 *
 * @author 鲲鹏
 * @since 2020-05-14
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
public class UserNotice extends Entity {

    private static final long serialVersionUID = 1L;

    /**
     * 公告标题
     */
    private String title;

    /**
     * 公告类型：1水务新闻 2政策法规
     */
    private Integer type;

    /**
     * 公告内容
     */
    private String content;

    /**
     * 附件
     */
    private String attachment;

    /**
     * 阅读量
     */
    private Integer viewNum;

    /**
     * 发布人
     */
    private Integer publishUser;

    /**
     * 发布时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date publishTime;
}
