package com.taauav.front.mapper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.taauav.front.entity.UserInspectQuestion;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.taauav.front.query.UserInspectQuestionQuery;
import com.taauav.front.vo.inspectquestion.InspectQuestionCategoryVo;
import com.taauav.front.vo.inspectquestion.UserInspectQuestionInfoVo;
import com.taauav.front.vo.inspectquestion.UserInspectQuestionListVo;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * <p>
 * 问题管理 Mapper 接口
 * </p>
 *
 * @author 鲲鹏
 * @since 2020-05-14
 */
public interface UserInspectQuestionMapper extends BaseMapper<UserInspectQuestion> {

    /**
     * 获取巡检问题列表
     *
     * @param query 查询条件
     * @return
     */
    List<UserInspectQuestionListVo> getInspectQuestionList(IPage<UserInspectQuestionListVo> page, @RequestParam("query") UserInspectQuestionQuery query);

    /**
     * 根据ID获取问题详情
     *
     * @param id 问题ID
     * @return
     */
    UserInspectQuestionInfoVo getInspectQuestionInfoById(Integer id);

    /**
     * 获取巡检问题分类统计列表
     *
     * @return
     */
    List<InspectQuestionCategoryVo> getInspectQuestionCategoryList();

}
