package com.taauav.front.mapper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.taauav.admin.entity.TauvWaterData;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.taauav.front.query.UserWaterDataQuery;
import com.taauav.front.vo.waterdata.UserWaterDataListVo;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * <p>
 * 水质数据表 Mapper 接口
 * </p>
 *
 * @author 鲲鹏
 * @since 2020-05-15
 */
public interface UserWaterDataMapper extends BaseMapper<TauvWaterData> {

    /**
     * 获取水质数据列表
     *
     * @param page  分页
     * @param query 查询条件
     * @return
     */
    List<UserWaterDataListVo> getWaterDataList(IPage<UserWaterDataListVo> page, @RequestParam("query") UserWaterDataQuery query);

}
