package com.taauav.front.service;

import com.taauav.admin.entity.SysAuthGroupAccess;
import com.taauav.front.entity.UserAuthGroupAccess;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 用户组明细表 服务类
 * </p>
 *
 * @author 鲲鹏
 * @since 2020-05-16
 */
public interface IUserAuthGroupAccessService extends IService<UserAuthGroupAccess> {

    /**
     * 根据角色编号获取用户列表
     *
     * @param groupId
     * @return
     */
    List<UserAuthGroupAccess> getListByGroupid(Integer groupId);

    /**
     * 添加用户角色
     *
     * @param adminId
     * @param groupIds
     * @return
     */
    Map<String, String> add(Integer adminId, String groupIds);

    /**
     * 根据用户获取角色列表
     *
     * @param adminId
     * @return
     */
    List<UserAuthGroupAccess> getListByAdmin(Integer adminId);

}
