package com.taauav.front.service;

import com.taauav.admin.entity.SysAuthGroup;
import com.taauav.common.bean.Response;
import com.taauav.common.service.IBaseService;
import com.taauav.front.entity.UserAuthGroup;
import com.taauav.front.query.UserAuthGroupQuery;

import java.util.List;

/**
 * <p>
 * 外部用户角色表 服务类
 * </p>
 *
 * @author 鲲鹏
 * @since 2020-05-14
 */
public interface IUserAuthGroupService extends IBaseService<UserAuthGroup> {

    /**
     * 获取角色列表
     *
     * @param query 查询条件
     * @return
     */
    Response getList(UserAuthGroupQuery query);

    /**
     * 添加角色
     *
     * @param entity 实体对象
     * @return
     */
    Response add(UserAuthGroup entity);

    /**
     * 获取角色详情
     *
     * @param id 角色ID
     * @return
     */
    Response info(Integer id);

    /**
     * 编辑角色
     *
     * @param entity 实体对象
     * @return
     */
    Response edit(UserAuthGroup entity);

    /**
     * 删除角色
     *
     * @param id 角色ID
     * @return
     */
    Response drop(Integer id);

    /**
     * 设置状态
     *
     * @param entity 实体对象
     * @return
     */
    Response setStatus(UserAuthGroup entity);

    /**
     * 获取角色列表
     *
     * @return
     */
    Response getAuthGroupList();

    /**
     * 获取外部角色
     *
     * @param authGroupIds
     * @return
     */
    String getAuthGroupName(String authGroupIds);

    /**
     * 根据用户编号获取权限
     *
     * @param adminId
     * @return
     */
    List<UserAuthGroup> getAuthGroups(Integer adminId);

}
