package com.taauav.front.service;

import com.taauav.common.bean.Menu;
import com.taauav.common.bean.Response;
import com.taauav.common.service.IBaseService;
import com.taauav.front.entity.UserAdmin;
import com.taauav.front.entity.UserAuthRule;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author 鲲鹏
 * @since 2020-05-16
 */
public interface IUserAuthRuleService extends IBaseService<UserAuthRule> {

    /**
     * 获取用户拥有的菜单权限
     *
     * @return
     */
    List<UserAuthRule> getAuthRules();

    /**
     * 获取所有菜单-列表页
     *
     * @param request
     * @return
     */
    Response getRulePageList(Map<String, String> request);

    /**
     * 菜单页面-编辑
     *
     * @param authRule
     * @return
     */
    Response editRule(UserAuthRule authRule);

    /**
     * 菜单页面-添加
     *
     * @param authRule
     * @return
     */
    Response addRule(UserAuthRule authRule);

    /**
     * 菜单页面-删除
     *
     * @param authRule
     * @return
     */
    Response delRule(UserAuthRule authRule);

    /**
     * 根据ID获取一条数据
     *
     * @param id
     * @return
     */
    UserAuthRule getInfoById(Integer id);

    /**
     * 获取菜单列表
     *
     * @return
     */
    List<Map<String, Object>> getRuleList(Integer adminId);

    /**
     * 修改菜单状态
     *
     * @param map
     * @return
     */
    Response editStatus(Map<String, String> map);

    /**
     * 根据父级编号获取数据
     *
     * @param pid
     * @return
     */
    List<Map<String, Object>> getListByPid(Integer pid);

    /**
     * 获取菜单的树状
     *
     * @return
     */
    List<Menu> buildTreeMenu();

    /**
     * 获取用户权限
     *
     * @param info
     * @return
     */
    String getPermission(UserAdmin info);

}
