package com.taauav.front.service;

import com.taauav.admin.entity.TauvInspect;
import com.taauav.admin.entity.TauvInspectDriver;
import com.taauav.common.bean.Response;
import com.taauav.common.service.IBaseService;
import com.taauav.front.entity.UserAdmin;
import com.taauav.front.query.UserInspectDriverQuery;

import java.util.Map;

/**
 * <p>
 * 巡检任务 服务类
 * </p>
 *
 * @author 鲲鹏
 * @since 2020-05-14
 */
public interface IUserInspectDriverService extends IBaseService<TauvInspectDriver> {

    /**
     * 添加任务对应数据
     *
     * @param inspect
     * @return
     */
    String batchAddData(TauvInspect inspect);

    /**
     * 获取巡检任务列表
     *
     * @param map 查询条件
     * @return
     */
    Response getList(Map<String, Object> map);

    /**
     * 任务详情
     *
     * @param id
     * @return
     */
    Response detail(Integer id);

}
