package com.taauav.front.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.taauav.admin.entity.TauvWaterAlarmInfo;
import com.taauav.admin.mapper.TauvWaterAlarmInfoMapper;
import com.taauav.common.service.impl.BaseServiceImpl;
import com.taauav.front.mapper.UserWaterAlarmInfoMapper;
import com.taauav.front.service.IUserWaterAlarmInfoService;
import com.taauav.front.vo.wateralarm.UserWaterAlarmInfoListVo;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 水质报警附表 服务实现类
 * </p>
 *
 * @author 鲲鹏
 * @since 2020-05-15
 */
@Service
public class UserWaterAlarmInfoServiceImpl extends BaseServiceImpl<UserWaterAlarmInfoMapper, TauvWaterAlarmInfo> implements IUserWaterAlarmInfoService {

    @Autowired
    private TauvWaterAlarmInfoMapper waterAlarmInfoMapper;

    /**
     * 根据水质报警信息ID获取报警信息列表
     *
     * @param waterAlarmId 水质报警ID
     * @return
     */
    @Override
    public List<UserWaterAlarmInfoListVo> getWaterAlarmInfoList(Integer waterAlarmId) {
        // 查询条件
        QueryWrapper<TauvWaterAlarmInfo> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("water_alarm_id", waterAlarmId);
        queryWrapper.eq("status", 1);
        queryWrapper.eq("mark", 1);
        List<TauvWaterAlarmInfo> waterAlarmInfoList = waterAlarmInfoMapper.selectList(queryWrapper);
        List<UserWaterAlarmInfoListVo> waterAlarmInfoListVoList = new ArrayList<>();
        if (!waterAlarmInfoList.isEmpty()) {
            waterAlarmInfoList.forEach(item -> {
                UserWaterAlarmInfoListVo userWaterAlarmInfoListVo = new UserWaterAlarmInfoListVo();
                // 拷贝属性
                BeanUtils.copyProperties(item, userWaterAlarmInfoListVo);
                waterAlarmInfoListVoList.add(userWaterAlarmInfoListVo);
            });
        }
        return waterAlarmInfoListVoList;
    }
}
