package com.taauav.front.vo.inspectquestion;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigInteger;
import java.util.Date;

/**
 * 巡检问题列表Vo
 */
@Data
public class UserInspectQuestionListVo {

    /**
     * 问题ID
     */
    private Integer id;

    /**
     * 问题编号
     */
    private String questionNo;

    /**
     * 问题处理状态
     */
    private Integer status;

    /**
     * 状态描述
     */
    private String statusName;

    /**
     * 问题图片地址
     */
    private String fileSrc;

    /**
     * 问题描述内容
     */
    private String questionType;

    /**
     * 问题描述
     */
    private String description;

    /**
     * 河湖ID
     */
    private Integer driverId;

    /**
     * 河湖名称
     */
    private String driverName;

    /**
     * 区划ID
     */
    private BigInteger driverArea;

    /**
     * 区划名称
     */
    private String driverAreaName;

    /**
     * 巡检时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date inspectTime;

}
