package com.taauav.front.vo.usernotice;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
public class UserNoticeListVo {

    /**
     * 公告ID
     */
    private Integer id;

    /**
     * 公告标题
     */
    private String title;

    /**
     * 公告类型：1水务新闻 2政策法规
     */
    private Integer type;

    /**
     * 公告类型描述
     */
    private String typeName;

    /**
     * 公告内容
     */
    private String content;

    /**
     * 附件
     */
    private String attachment;

    /**
     * 阅读量
     */
    private Integer viewNum;

    /**
     * 发布状态：1已发布 2未发布
     */
    private Integer status;

    /**
     * 状态描述
     */
    private String statusName;

    /**
     * 发布人
     */
    private Integer publishUser;

    /**
     * 发布人名称
     */
    private String publishUserName;

    /**
     * 发布时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date publishTime;

}
