package com.taauav.front.vo.userwaterspectrum;

import java.time.LocalDateTime;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.taauav.common.domain.Entity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

/**
 * <p>
 * 多光谱图表
 * </p>
 *
 * @author 鲲鹏
 * @since 2020-05-15
 */
@Data
public class UserWaterSpectrumListVo {

    /**
     * 多光谱数据ID
     */
    private Integer id;

    /**
     * 区属名称
     */
    private String areaName;

    /**
     * 河湖名称
     */
    private String driverName;

    /**
     * 巡检时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date inspectTime;

    /**
     * 化学需氧量多光谱路径
     */
    private String codPic;

    /**
     * 氨氮多光谱路径
     */
    private String nh3nPic;

    /**
     * 总磷多光谱路径
     */
    private String tpPic;

    /**
     * 总氮多光谱路径
     */
    private String tnPic;

    /**
     * 溶解氧多光谱路径
     */
    private String doPic;

    /**
     * 浊度多光谱路径
     */
    private String tubPic;

}
