package com.taauav.front.vo.wateralarm;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

/**
 * 水质报警信息详情Vo
 */
@Data
public class UserWaterAlarmInfoVo {

    /**
     * 水质报警ID
     */
    private Integer id;

    /**
     * 报警编码
     */
    private String alarmSn;

    /**
     * 河湖名称
     */
    private String driverName;

    /**
     * 巡检日期
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date inspectTime;

    /**
     * 水质标准
     */
    private String alarmStandard;

    /**
     * 水质报警信息列表
     */
    private List<UserWaterAlarmInfoListVo> waterAlarmInfoList;

}
