package com.taauav.front.vo.waterwarn;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigInteger;
import java.util.Date;

/**
 * 水质预警列表Vo
 */
@Data
public class UserWaterWarnListVo {

    /**
     * 预警编号
     */
    private String warnSn;

    /**
     * 区属ID
     */
    private BigInteger driverArea;

    /**
     * 区属名称
     */
    private String driverAreaName;

    /**
     * 河道ID
     */
    private Integer driverId;

    /**
     * 河流名称
     */
    private String driverName;

    /**
     * 巡检日期
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date inspectTime;

    /**
     * 预警类型：1水质富营养化 2水生藻类植物
     */
    private Integer warnType;

    /**
     * 预警类型描述
     */
    private String warnTypeName;

    /**
     * 报警内容
     */
    private String warnContent;

    /**
     * 预警级别：1一级 2二级 3三级 4四级 5五级
     */
    private Integer warnLevel;

    /**
     * 预警级别描述
     */
    private String warnLevelName;

    /**
     * 状态
     */
    private Integer status;

    /**
     * 状态描述
     */
    private String statusName;

}
