package com.taauav.tool.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.taauav.tool.entity.GenTable;
import com.taauav.tool.entity.GenTableColumn;

import java.util.List;

/**
 * 业务字段 数据层
 * 
 * @author ruoyi
 */
public interface GenTableColumnMapper extends BaseMapper<GenTableColumn>
{
    /**
     * 根据表名称查询列信息
     * 
     * @param tableName 表名称
     * @return 列信息
     */
    public List<GenTableColumn> selectDbTableColumnsByName(String tableName);
    



    /**
     * 修改业务字段
     * 
     * @param genTableColumn 业务字段信息
     * @return 结果
     */
    public int updateGenTableColumn(GenTableColumn genTableColumn);

    /**
     * 批量删除业务字段
     * 
     * @param ids 需要删除的数据ID
     * @return 结果
     */
    public int deleteGenTableColumnByIds(Integer[] ids);

}